Add set_git_dir() function
[git/git.git] / git-sh-setup.sh
CommitLineData
b33e9666
LT
1#!/bin/sh
2#
ae2b0f15
JH
3# This is included in commands that either have to be run from the toplevel
4# of the repository, or with GIT_DIR environment variable properly.
5# If the GIT_DIR does not look like the right correct git-repository,
6# it dies.
b33e9666 7
365527ad
JH
8# Having this variable in your environment would break scripts because
9# you would cause "cd" to be be taken to unexpected places. If you
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
12unset CDPATH
13
b33e9666 14die() {
8098a178 15 echo >&2 "$@"
b33e9666
LT
16 exit 1
17}
18
d025524d
FK
19usage() {
20 die "Usage: $0 $USAGE"
21}
22
f9474132
SP
23set_reflog_action() {
24 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
25 then
26 GIT_REFLOG_ACTION="$*"
27 export GIT_REFLOG_ACTION
28 fi
29}
30
ef0c2abf
AR
31git_editor() {
32 GIT_EDITOR=${GIT_EDITOR:-$(git config core.editor || echo ${VISUAL:-${EDITOR}})}
33 case "$GIT_EDITOR,$TERM" in
34 ,dumb)
35 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
36 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
37 echo >&2 "Please set one of these variables to an appropriate"
38 echo >&2 "editor or run $0 with options that will not cause an"
39 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
40 exit 1
41 ;;
42 esac
43 "${GIT_EDITOR:-vi}" "$1"
44}
45
4b441f47 46is_bare_repository () {
5be60078 47 git rev-parse --is-bare-repository
4b441f47
JH
48}
49
9fde9401 50cd_to_toplevel () {
5be60078 51 cdup=$(git rev-parse --show-cdup)
9fde9401
JH
52 if test ! -z "$cdup"
53 then
54 cd "$cdup" || {
55 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
56 exit 1
57 }
58 fi
59}
60
7eff28a9 61require_work_tree () {
5be60078
JH
62 test $(git rev-parse --is-inside-work-tree) = true &&
63 test $(git rev-parse --is-inside-git-dir) = false ||
7eff28a9
SP
64 die "fatal: $0 cannot be used without a working tree."
65}
66
0cae2346
JS
67get_author_ident_from_commit () {
68 pick_author_script='
69 /^author /{
70 s/'\''/'\''\\'\'\''/g
71 h
72 s/^author \([^<]*\) <[^>]*> .*$/\1/
73 s/'\''/'\''\'\'\''/g
74 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
75
76 g
77 s/^author [^<]* <\([^>]*\)> .*$/\1/
78 s/'\''/'\''\'\'\''/g
79 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
80
81 g
82 s/^author [^<]* <[^>]*> \(.*\)$/\1/
83 s/'\''/'\''\'\'\''/g
84 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
85
86 q
87 }
88 '
89 encoding=$(git config i18n.commitencoding || echo UTF-8)
90 git show -s --pretty=raw --encoding="$encoding" "$1" |
91 LANG=C LC_ALL=C sed -ne "$pick_author_script"
92}
93
d025524d
FK
94if [ -z "$LONG_USAGE" ]
95then
96 LONG_USAGE="Usage: $0 $USAGE"
97else
98 LONG_USAGE="Usage: $0 $USAGE
99
100$LONG_USAGE"
101fi
102
103case "$1" in
cad1ed95 104 -h|--h|--he|--hel|--help)
d025524d
FK
105 echo "$LONG_USAGE"
106 exit
107esac
108
c8769f76 109# Make sure we are in a valid repository of a vintage we understand.
d025524d
FK
110if [ -z "$SUBDIRECTORY_OK" ]
111then
112 : ${GIT_DIR=.git}
5be60078 113 GIT_DIR=$(GIT_DIR="$GIT_DIR" git rev-parse --git-dir) || {
120b0dfb
JH
114 exit=$?
115 echo >&2 "You need to run this command from the toplevel of the working tree."
116 exit $exit
117 }
d025524d 118else
5be60078 119 GIT_DIR=$(git rev-parse --git-dir) || exit
d025524d 120fi
c8769f76 121: ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}